interface IPage extends ExtendedPage {
    readonly id : number;
    title : string;
    getPageTitle(prefix: string): string;
}

interface ExtendedPage {
    menu: string;
}

interface Authable {
    auth: string;
}

class Dashboard implements IPage, Authable {
    menu: string;
    auth: string;
    id: number;
    title: string;
    getPageTitle(prefix: string): string {
        throw new Error("Method not implemented.");
    }

}

class Index implements IPage  {
    id: number;
    title: string;
    getPageTitle(prefix: string): string {
        return this.title;
    }

    constructor(id: number, title: string) {
        this.id = id;
        this.title = title;
    }
    menu: string;

}

let index = new Index(1, 'Home Page');
console.log(index.getPageTitle('hello'));

let admin = new Dashboard();
console.log(admin);

interface FuncFoo {
    (title: string): string;
}

let foo:  FuncFoo = function(title: string): string {
    return title;
}

console.log(foo('hello world'));

interface indexArray {
    [index: number]: string
}

interface stringArray {
    [index: string]: string
}

let strings: indexArray;

strings = ['a','b','c'];

console.log(strings[2]);

let strings2: stringArray = {};
strings2['one'] = 'hello';
strings2['two'] = 'world';

console.log(strings2['two']);




